//+------------------------------------------------------------------+
//|                               Copyright 2015, MathematicTrading. |
//+------------------------------------------------------------------+

#property copyright "Mathematic Trading"
#property link      "https://www.mql5.com/en/users/mathematic"
#property version   "1.00"
#include <CustomFunctions01.mqh>

extern string _________________________or="Order Settings";
extern int Magic=123456;
extern double Stop_Loss=20;
extern double Take_Profit=20;
extern double Lot=0.1;
extern string ____________________________________________________________is="++++++++++ Indicator Settings ++++++++++";
extern int fast_ema_period=12;//Fast EMA Period  
extern int slow_ema_period=26;//Slow EMA Period
extern int signal_period=9;//Signal Period
extern bool Use_Signal=true;


//Not using initialization instructions
int init()
{
return(0);
}

//Not using deinitializaion instructions
int deinit()
{
return(0);
}

//EA Starts here
//----------------------------------------------------------------

int start()
{
double lot, SL=0, TP=0;
int i, k;
bool BUY=false;
bool SELL=false;

//Create multiplyer to convert price to pips
double pipValue;
if(GetPipValue()>0.001){
pipValue = 100;
}
else{
pipValue = 10000;
}
   

   if(Volume[0]==1){    //If the Volume at the current bar is equal to 1... ? I don't understand the purpose this serves.
   
      //The Price value at swing points.
      double H_Price[3];
      double L_Price[3];
      double H_Macd[3];
      double L_Macd[3];
      
      //The time value at swing points.
      datetime H_Price_T[3];
      datetime L_Price_T[3];
      datetime H_Macd_T[3];
      datetime L_Macd_T[3];
      
      //Looking for Highs on the Zig zag Price! (Creating the H_Price and H_Price_T values)
      int c=0;
      double aux=0;
      for(i=1;i<Bars;i++){
         aux=iCustom(NULL,0,"ZigZag_JayDasilva","",fast_ema_period,slow_ema_period,signal_period,1,i);
            if(aux!=0){
            H_Price[c]=aux;
            H_Price_T[c]=Time[i];
            c++;
            }
         if(c==5) break;
      }  
      
      //Looking for Lows on the Zig zag Price! (Creating the L_Price and L_Price_T values)
      c=0;
      aux=0;
      for(i=1;i<Bars;i++){
         aux=iCustom(NULL,0,"ZigZag_JayDasilva","",fast_ema_period,slow_ema_period,signal_period,2,i);
            if(aux!=0){
            L_Price[c]=aux;
            L_Price_T[c]=Time[i];
            c++;
            }
         if(c==2) break;
      }
      
      //Looking for Highs on the Zig zag MACD!(Creating the H_Macd and H_Macd_T values)
      c=0;
      aux=0;
      for(i=1;i<Bars;i++){
         aux=iCustom(NULL,0,"ZigZag_MACD_JayDasilva","",fast_ema_period,slow_ema_period,signal_period,Use_Signal,3,i);
            if(aux!=0){
            H_Macd[c]=aux;
            H_Macd_T[c]=Time[i];
            c++;
            }
         if(c==2) break;
      }
      
      //Looking for Lows on the Zig zag MACD! (Creating the L_Macd and L_Macd_T values)
      c=0;
      aux=0;
      for(i=1;i<Bars;i++){
         aux=iCustom(NULL,0,"ZigZag_MACD_JayDasilva","",fast_ema_period,slow_ema_period,signal_period,Use_Signal,4,i);
            if(aux!=0){
            L_Macd[c]=aux;
            L_Macd_T[c]=Time[i];
            c++;
            }
         if(c==2) break;
   }
   
// Insert Your Rules Here
//-----------------------------------------------------------------------------------
   
      //Divergence example:
      if(H_Price[0]>H_Price[1])
      if(H_Macd[0]<H_Macd[1])   
      {
         Line(H_Price_T[1],H_Price[1],H_Price_T[0],H_Price[0],clrBlue);                      
      }
      
      Comment("Price High 1: " + H_Price[1], "\nPrice Low 1: " + L_Price[1]);
      
            
      if(BUY){
        lot=Lot;
        if(Stop_Loss!=0) SL=Bid-Stop_Loss*10*Point;
        if(Take_Profit!=0) TP=Bid+Take_Profit*10*Point;
        k=OrderSend(Symbol(),OP_BUY,lot,Ask,MarketInfo(Symbol(),MODE_SPREAD),SL,TP,lot,Magic);
      }
      
      if(SELL){
        lot=Lot;
        if(Stop_Loss!=0) SL=Bid+Stop_Loss*10*Point;
        if(Take_Profit!=0) TP=Bid-Take_Profit*10*Point;
        k=OrderSend(Symbol(),OP_SELL,lot,Bid,MarketInfo(Symbol(),MODE_SPREAD),SL,TP,lot,Magic);
      }
      
   }


//}               <---Why is this here?
return(0);  //    <---I don't understand what this is for.

}
// ************* EA End *************

// Functions ----------------------------------------------------

// A function called "Line" to easily draw lines with the new values.
string name="Jay";
void Line(datetime ax, double a, datetime bx, double b, color cl){
  string n=name+(string)ax+(string)a+(string)b;
  ObjectDelete(n);
  ObjectCreate(0,n,OBJ_GANNLINE,0,ax,a,bx,b);
  ObjectSetInteger(0,n,OBJPROP_RAY_RIGHT,FALSE);
  ObjectSetInteger(0,n,OBJPROP_COLOR,cl);
  ObjectSetInteger(0,n,OBJPROP_SELECTABLE,true);
  ObjectSetInteger(0,n,OBJPROP_BACK,False);
  ObjectSetInteger(0,n,OBJPROP_HIDDEN,true);
   return;
}
